import BD from '../connection.js';
import oracledb from 'oracledb';

const NovoCodigo = {
    INTERVAL: 1,
    COL_SIZE: 10,
    CAST_TO_NUMERIC: false,
    
    formatSequential( SEQUENTIAL, CAST_TO_NUMERIC, COL_SIZE){
        return CAST_TO_NUMERIC ? SEQUENTIAL : SEQUENTIAL.toString().padStart(COL_SIZE, '0');
    },

    async executeProcedure(procedureName, params){
        let { TABLE_NAME, INTERVAL, COL_SIZE, CAST_TO_NUMERIC, NRORG } = params;
        INTERVAL = INTERVAL || this.INTERVAL;
        COL_SIZE = COL_SIZE || this.COL_SIZE;
        CAST_TO_NUMERIC = typeof CAST_TO_NUMERIC == "boolean" ? CAST_TO_NUMERIC : this.CAST_TO_NUMERIC;
        const paramProcedure = Object.assign(
            BD.createParam('P_CONTADOR',   TABLE_NAME, 'IN',  'STRING'),
            BD.createParam('P_SEQUENCIAL', null,       'OUT', 'NUMBER', 20),
            BD.createParam('P_QTDE',       INTERVAL,   'IN',  'NUMBER'),
            BD.createParam('P_NRORG',      NRORG,      'IN'),
        );
        const result = await BD.execProc(procedureName, paramProcedure);
        const { P_SEQUENCIAL } = result;
        return this.formatSequential(P_SEQUENCIAL, CAST_TO_NUMERIC, COL_SIZE);
    },

    async getCodeByTableName ( TABLE_NAME, NRORG, INTERVAL, COL_SIZE, CAST_TO_NUMERIC ){
        const P_SEQUENCIAL = await this.executeProcedure('NOVO_CODIGO', {
            TABLE_NAME,
            NRORG,
            INTERVAL,
            COL_SIZE,
            CAST_TO_NUMERIC
        });
        return P_SEQUENCIAL;
    },

    async getCodeByTableNameNT ( TABLE_NAME, NRORG, INTERVAL, COL_SIZE, CAST_TO_NUMERIC ){
        const P_SEQUENCIAL = await this.executeProcedure('NOVO_CODIGO_NT', {
            TABLE_NAME,
            NRORG,
            INTERVAL,
            COL_SIZE,
            CAST_TO_NUMERIC
        });
        return P_SEQUENCIAL;
    }
}

export default NovoCodigo;