CREATE TABLE ZHU_LOG
(
  ID INT NOT NULL,
  ROUTE VARCHAR2(4000) NOT NULL,
  METHOD VARCHAR2(10) NOT NULL,
  REQUEST_TYPE VARCHAR2(20) NOT NULL,
  BEGIN_REQUEST DATE NOT NULL,
  END_REQUEST DATE NOT NULL,
  USER_DATA VARCHAR2(4000),
  CONTEXT_DATA VARCHAR2(4000),
  REQUEST_CONTENT CLOB NOT NULL,
  RESPONSE_CONTENT CLOB NOT NULL,
  HTTP_RESPONSE_CODE NUMBER(3,0),
  CONSTRAINT ZHU_LOG_PK PRIMARY KEY
  (
    ID
  )
  ENABLE
);

ALTER TABLE ZHU_LOG
ADD CONSTRAINT ZHU_LOG_METHOD CHECK
(METHOD IN ('POST', 'GET', 'PUT', 'DELETE', 'OPTIONS'))
ENABLE;

ALTER TABLE ZHU_LOG
ADD CONSTRAINT ZHU_LOG_REQUEST_TYPE CHECK
(REQUEST_TYPE IN ('Empty', 'FilterData', 'Row', 'Dataset'))
ENABLE;